import { Contracts, ExtractDto } from "ts-extractor";
import { Plugin, SupportedApiItemKindType, PluginOptions, PluginResult, PluginResultData } from "../contracts/plugin";
import { ApiTypeParameter } from "../api-items/definitions/api-type-parameter";
import { ApiTypes } from "../api-items/api-type-list";
import { ReferenceRenderHandler } from "../contracts/serialized-api-item";
export declare abstract class BasePlugin<TKind extends Contracts.ApiBaseDefinition = Contracts.ApiDefinition> implements Plugin<TKind> {
    /**
     * Used to identify class as Plugin.
     */
    static TsDocsGenPlugin(): void;
    abstract SupportedApiDefinitionKind(): SupportedApiItemKindType[];
    CheckApiItem(item: TKind): boolean;
    protected RenderApiItemMetadata(apiItem: Contracts.ApiDefinition): string[];
    protected RenderTypeParameters(extractedData: ExtractDto, typeParameters: ApiTypeParameter[]): PluginResultData | undefined;
    protected RenderType(extractedData: ExtractDto, type: ApiTypes | undefined): PluginResultData | undefined;
    /**
     * Default reference rending with markdown links.
     * @param usedReferences populates given array with used references.
     */
    protected RenderReferences(extractedData: ExtractDto, usedReferences: string[]): ReferenceRenderHandler;
    abstract Render(options: PluginOptions, apiItem: TKind): PluginResult;
}
