import { Contracts } from "ts-extractor";
import { BasePlugin } from "./base-plugin";
import { PluginResultData, PluginOptions, SupportedApiItemKindType } from "../contracts/plugin";
import { ApiDefinitions } from "../api-items/api-definition-list";
export interface ApiContainer extends Contracts.ApiBaseDefinition {
    Members: Contracts.ApiItemReference[];
}
export interface ContainerMembersKindsGroup {
    Heading: string;
    Kinds: SupportedApiItemKindType[];
}
export interface RenderMemberGroupsOptions {
    IncludeHr: boolean;
    StartingHeadingLevel: number;
}
export declare abstract class ContainerPlugin<TKind extends ApiContainer> extends BasePlugin<TKind> {
    private getItemsReferenceByKind(list, members);
    protected RenderMemberGroups(pluginOptions: PluginOptions, list: ContainerMembersKindsGroup[], members: ApiDefinitions[], options?: Partial<RenderMemberGroupsOptions>): PluginResultData;
}
