import { Contracts } from "ts-extractor";
import { ApiTypeParameter } from "./definitions/api-type-parameter";
import { ApiParameter } from "./definitions/api-parameter";
import { ApiDefinitionBase } from "./api-definition-base";
import { ApiTypes } from "./api-type-list";
import { ReferenceRenderHandler } from "../contracts/serialized-api-item";
/**
 * Base class for callable api items.
 */
export declare abstract class ApiCallable<TKind extends Contracts.ApiCallableBaseDefinition> extends ApiDefinitionBase<TKind> {
    private parameters;
    readonly Parameters: ApiParameter[];
    private typeParameters;
    readonly TypeParameters: ApiTypeParameter[];
    private returnType;
    readonly ReturnType: ApiTypes | undefined;
    protected TypeParametersToString(render: ReferenceRenderHandler): string;
    protected ParametersToString(render: ReferenceRenderHandler): string;
    /**
     * Example: `<TValue>(arg: TValue): void`
     * @param typeDefChar If empty string, return type is not shown. @default ": "
     */
    protected CallableToString(render: ReferenceRenderHandler, typeDefChar?: string): string;
    protected CallableToSimpleString(): string;
}
