import { Contracts, ExtractDto } from "ts-extractor";
import { BaseApiItemClass } from "../abstractions/base-api-item";
import { SerializedApiDefinition, ReferenceRenderHandler } from "../contracts/serialized-api-item";
import { ApiItemReference } from "../contracts/api-item-reference";
import { ApiDefinitions } from "./api-definition-list";
import { ApiTypes } from "./api-type-list";
/**
 * Base definition class with helper functions.
 */
export declare abstract class ApiDefinitionBase<TKind extends Contracts.ApiBaseDefinition = Contracts.ApiBaseDefinition> extends BaseApiItemClass<TKind> implements SerializedApiDefinition<TKind> {
    private reference;
    constructor(extractedData: ExtractDto, apiItem: TKind, reference: ApiItemReference);
    readonly Name: string;
    readonly Reference: ApiItemReference;
    private parentItem;
    readonly ParentItem: ApiDefinitions | undefined;
    protected GetSerializedApiDefinition(reference: ApiItemReference): ApiDefinitions | undefined;
    protected TypeParametersToString(render: ReferenceRenderHandler, apiTypeParameters: ApiDefinitionBase[]): string;
    protected SerializedTypeToString(render: ReferenceRenderHandler, apiType: ApiTypes | undefined): string;
    abstract ToText(render?: ReferenceRenderHandler): string[];
    abstract ToHeadingText(): string;
}
