import * as ts from "typescript";
import { GeneratorConfiguration, WorkingGeneratorConfiguration } from "../contracts/generator-configuration";
import { Plugin } from "../contracts/plugin";
export declare class GeneratorConfigurationBuilder {
    private projectDirectory;
    constructor(projectDirectory: string);
    private configuration;
    private compilerOptions;
    private tsConfigLocation;
    private resolveProjectDirectory();
    private extractorFilterApiItem;
    /**
     * @param tsconfigLocation Relative `tsconfig.json` location from `projectDirectory`.
     */
    SetTsConfigLocation(tsconfigLocation: string): this;
    OverrideCompilerOptions(compilerOptions: Partial<ts.CompilerOptions>): this;
    /**
     * Override configuration with a new configuration object.
     *
     * @param configuration Partial configuration object.
     */
    OverrideConfiguration(configuration: Partial<WorkingGeneratorConfiguration>): this;
    SetExternalPackages(packages: string[]): this;
    SetOutputDirectory(outputDirectory: string): this;
    AddPlugins(plugins: Plugin[]): this;
    Build(entryFiles: string[]): Promise<GeneratorConfiguration>;
}
