import { ExtractDto } from "ts-extractor";
import { PluginResult } from "./contracts/plugin";
import { FileResult } from "./contracts/file-result";
import { ApiContainer } from "./abstractions/container-plugin";
export declare class FileManager {
    private extractedData;
    constructor(extractedData: ExtractDto);
    /**
     * <FileLocation, RenderedItems>
     */
    private filesList;
    /**
     * <ReferenceId, FileLocation>
     */
    private referenceToFile;
    private resolveMemberKindsList(apiItemKind);
    private renderTableOfContents(containerResult);
    AddEntryFile(itemResult: PluginResult<ApiContainer>): void;
    private addItemHeadings(headings, filePath);
    private resolveReferenceFile(referenceId);
    private removeBrokenLinks(result, referenceId);
    AddItem(itemResult: PluginResult<ApiContainer>, filePath: string): void;
    ToFilesOutput(): FileResult[];
}
